#! /usr/bin/perl

# program to compare 2 directories using diff
# 
# returns internal results as ...
# return 0  ->  directories are identical
# return 1  ->  missing needed argument count 
# return 2  ->  directory 1 is missing         
# return 3  ->  directory 2 is missing         

use strict;
use warnings;
use File::Basename;

my $err;
my $me = basename $0;

my $MaxArgs = $#ARGV + 1;
my $cmd;
my $dir1=$ARGV[0];
my $dir2=$ARGV[1];

# test for proper number of args
if ($MaxArgs < 2){
   print "Usage: $me <dir1> <dir2>\n";
   exit 1;
}

# test for dir1 to exist
if (! -d $dir1){
   print "$me: $dir1 doesnt exist\n";
   exit 2;
}

# test for dir2 to exist
if (! -d "$dir2") {
   print "$me: $dir2 doesnt exist\n";
   exit 3;
}

$cmd="diff -rq $dir1 $dir2 > /dev/null 2>&1";
$err = system($cmd);
if ($err != 0) {
   $cmd="diff -rq $dir1 $dir2";
   $err = system($cmd);
   print "$me: $dir1 $dir2 dont match\n";
   exit 1;
}
exit 0;
